From f4426362037f94b4270e27474f4dde040beead8e Mon Sep 17 00:00:00 2001
From: pierrat <pierrat@pc-pierrat-linux.cis2000.emse2000.local>
Date: Fri, 30 Nov 2012 15:31:23 +0100
Subject: [PATCH] Add support for Abaqus

Add abaqus lexer for inp files
Add filetypes.abaqus with keywords
Add a TagManager parser for Part/Assembly/Steps

Signed-off-by: touste
---
 data/filetype_extensions.conf   |    1 +
 data/filetypes.abaqus           |   55 ++++
 scintilla/Makefile.am           |    1 +
 scintilla/lexers/LexAbaqus.cxx  |  620 +++++++++++++++++++++++++++++++++++++++
 scintilla/makefile.win32        |    1 +
 scintilla/src/Catalogue.cxx     |    1 +
 src/filetypes.c                 |    8 +
 src/filetypes.h                 |    1 +
 src/highlighting.c              |    9 +
 src/highlightingmappings.h      |   25 ++
 src/symbols.c                   |   11 +
 tagmanager/ctags/Makefile.am    |    1 +
 tagmanager/ctags/abaqus.c       |  126 ++++++++
 tagmanager/ctags/makefile.win32 |    2 +-
 tagmanager/ctags/parsers.h      |    4 +-
 wscript                         |    1 +
 16 files changed, 865 insertions(+), 2 deletions(-)
 create mode 100644 data/filetypes.abaqus
 create mode 100644 scintilla/lexers/LexAbaqus.cxx
 create mode 100644 tagmanager/ctags/abaqus.c

diff --git a/data/filetype_extensions.conf b/data/filetype_extensions.conf
index 33eefe0..a2e02d4 100644
--- a/data/filetype_extensions.conf
+++ b/data/filetype_extensions.conf
@@ -2,6 +2,7 @@
 # Insert as many items as you want, seperate them with a ";".
 # See Geany's main documentation for details.
 [Extensions]
+Abaqus=*.inp;
 Abc=*.abc;*.abp;
 ActionScript=*.as;
 Ada=*.adb;*.ads;
diff --git a/data/filetypes.abaqus b/data/filetypes.abaqus
new file mode 100644
index 0000000..5c70aa7
--- /dev/null
+++ b/data/filetypes.abaqus
@@ -0,0 +1,55 @@
+# For complete documentation of this file, please see Geany's main documentation
+[styling]
+# Edit these in the colorscheme .conf file instead
+default=default
+comment=comment_line
+commentblock=comment_line
+number=number
+string=string_1
+operator=operator
+word=keyword_1
+preprocessor=preprocessor
+command=string_eol
+word2==keyword_2
+function=function
+
+[keywords]
+# all items must be in one line
+primary =*ACOUSTIC *ADAPTIVE *ADJUST *AMPLITUDE *ANISOTROPIC *ANNEAL *ASSEMBLY *ASYMMETRIC-AXISYMMETRIC *AXIAL *BASE *BASELINE *BEAM *BIAXIAL *BOUNDARY *BUCKLE *BUCKLING *CAP *CAST *CAVITY *CECHARGE *CECURRENT *CENTROID *CFILM *CFLOW *CFLUX *CHANGE *CLAY *CLEARANCE *CLOAD *COHESIVE *COMBINED *COMPLEX *CONCRETE *CONDUCTIVITY *CONNECTOR *CONSTRAINT *CONTACT *CONTOUR *CONTROLS *CORRELATION *CO-SIMULATION *COUPLED *COUPLING *CRADIATE *CRUSHABLE *CYCLED *CYCLIC *D *DAMAGE *DAMPING *DASHPOT *DEBOND *DECHARGE *DECURRENT *DEFORMATION *DENSITY *DEPVAR *DETONATION *DFLOW *DFLUX *DIELECTRIC *DIFFUSIVITY *DIRECT *DISPLAY *DISTRIBUTING *DLOAD *DRAG *DRUCKER *DSECHARGE *DSECURRENT *DSFLOW *DSFLUX *DSLOAD *DYNAMIC *EL *EL *ELASTIC *ELCOPY *ELECTRICAL *ELECTROMAGNETIC *ELEMENT *ELGEN *ELSET *EMBEDDED *EMISSIVITY *END *ENERGY *ENRICHMENT *ENRICHMENT *EOS *EPJOINT *EQUATION *EXPANSION *FAIL *FAIL *FAILURE *FASTENER *FIELD *FILE *FILM *FLOW *FOUNDATION *FRACTURE *FRAME *FREQUENCY *GAP *GASKET *GEL *GEOSTATIC *GLOBAL *HEADING *HEAT *HEATCAP *HOURGLASS *HYPERELASTIC *HYPERFOAM *HYPOELASTIC *HYSTERESIS *IMPEDANCE *IMPERFECTION *IMPORT *INCIDENT *INCLUDE *INCREMENTATION *INELASTIC *INITIAL *INSTANCE *INTERFACE *ITS *JOINT *JOINTED *JOULE *KAPPA *KINEMATIC *LATENT *LOAD *MAGNETIC *MAP *MASS *MATERIAL *MATRIX *MEMBRANE *MODAL *MODEL *MOHR *MOISTURE *MOLECULAR *MONITOR *MOTION *MPC *MULLINS *M1 *M2 *NCOPY *NFILL *NGEN *NMAP *NO *NODAL *NODE *NONSTRUCTURAL *NORMAL *NSET *ORIENTATION *ORNL *OUTPUT *PARAMETER *PART *PERIODIC *PERMEABILITY *PHYSICAL *PIEZOELECTRIC *PIPE-SOIL *PLANAR *PLASTIC *POROUS *POST *POTENTIAL *PREPRINT *PRESSURE *PRESTRESS *PRE-TENSION *PRINT *PSD- *RADIATE *RADIATION *RANDOM *RATE *RATIOS *REBAR *REFLECTION *RELEASE *RESPONSE *RESTART *RETAINED *RIGID *RIGID *ROTARY *SECTION *SELECT *SFILM *SFLOW *SHEAR *SHELL *SIMPEDANCE *SIMPLE *SLIDE *SLOAD *SOILS *SOLID *SOLUBILITY *SOLUTION *SOLVER *SORPTION *SPECIFIC *SPECTRUM *SPRING *SRADIATE *STATIC *STEADY *STEADY *STEP *SUBMODEL *SUBSTRUCTURE *SURFACE *SWELLING *SYMMETRIC *SYSTEM *TEMPERATURE *TENSION *THERMAL *TIE *TIME *TORQUE *TORQUE *TRANSFORM *TRANSPORT *TRANSVERSE *TRIAXIAL *TRS *UEL *UNDEX *UNIAXIAL *USER *VIEWFACTOR *VISCO *VISCOELASTIC *VISCOUS *VOID *VOLUMETRIC *ACOUSTIC *ACOUSTIC *ADAPTIVE *ADJUST *AMPLITUDE *ANISOTROPIC *ANNEAL *ASSEMBLY *AXIAL *BEAM *BIAXIAL *BLOCKAGE *BOND *BOUNDARY *BRITTLE *BULK *CAP *CAPACITY *CAST *CENTROID *CFILM *CFLUX *CLAY *CLEARANCE *CLOAD *COHESIVE *COMBINED *CONCRETE *CONDUCTIVITY *CONNECTOR *CONNECTOR *CONTACT *CONWEP *CO-SIMULATION *COUPLING *CRADIATE *CRUSHABLE *CRUSHABLE *CYCLIC *DAMAGE *DAMPING *DASHPOT *DENSITY *DEPVAR *DETONATION *DFLUX *DIAGNOSTICS *DISPLAY *DISTRIBUTING *DISTRIBUTION *DLOAD *DRUCKER *DSFLUX *DSLOAD *DYNAMIC *EL *ELASTIC *ELCOPY *ELEMENT *ELGEN *ELSET *EMBEDDED *END *ENERGY *EOS *EQUATION *EULERIAN *EXPANSION *EXTREME *FABRIC *FAIL *FASTENER *FIELD *FILE *FILM *FILM *FILTER *FIXED *FRACTURE *GAP *GAS *HEADING *HEATCAP *HYPERELASTIC *HYPERFOAM *IMPEDANCE *IMPERFECTION *IMPORT *INCIDENT *INCLUDE *INCREMENTATION *INELASTIC *INITIAL *INSTANCE *INTEGRATED *KINEMATIC *LATENT *LOADING *LOW *MASS *MATERIAL *MEDIA *MEMBRANE *MOHR *MOLECULAR *MONITOR *MPC *MULLINS *M1 *M2 *NCOPY *NFILL *NGEN *NMAP *NODAL *NODE *NONSTRUCTURAL *NORMAL *NSET *ORIENTATION *OUTPUT *PARAMETER *PART *PERIODIC *PHYSICAL *PLANAR *PLASTIC *POROUS *POTENTIAL *PREPRINT *PRINT *RADIATE *RATE *REACTION *REBAR *RESTART *RIGID *ROTARY *SECTION *SFILM *SHEAR *SHELL *SIMPEDANCE *SIMPLE *SOLID *SPECIFIC *SPRING *SRADIATE *STEADY *STEP *SUBCYCLING *SUBMODEL *SURFACE *SYSTEM *TEMPERATURE *TENSILE *TENSION *THERMAL *TIE *TIME *TORQUE *TRACER *TRANSFORM *TRANSVERSE *TRIAXIAL *TRS *UEL *UNDEX *UNIAXIAL *UNIAXIAL *UNLOADING *USER *VARIABLE *VISCOELASTIC *VISCOSITY *VOID *VOLUMETRIC *AQUA *C *CLOAD *D *DLOAD *INITIAL *WAVE *WIND *AMPLITUDE *ASSEMBLY *BOUNDARY *CFD *CFLUX *CLOAD *CONDUCTIVITY *CONTROLS *DENSITY *DFLOW *DFLUX *DISTRIBUTION *DISTRIBUTION *DLOAD *DSFLUX *DSLOAD *ELCOPY *ELEMENT *ELGEN *ELSET *END *EOS *EXPANSION *HEADING *INCLUDE *INITIAL *INSTANCE *MATERIAL *MOMENTUM *NCOPY *NFILL *NGEN *NMAP *NODE *NODE *NSET *OUTPUT *PART *PRESSURE *RESTART *SOLID *SPECIFIC *STEP *SURFACE *SURFACE *SYSTEM *TRANSFORM *TRANSPORT *TURBULENCE *VISCOSITY
+
+
+[settings]
+# default extension used when saving files
+extension=inp
+
+# the following characters are these which a "word" can contains, see documentation
+#wordchars=_abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789
+
+# single comments, like # in this file
+comment_single=**
+# multiline comments
+#comment_open=
+#comment_close=
+
+# set to false if a comment character/string should start at column 0 of a line, true uses any
+# indentation of the line, e.g. setting to true causes the following on pressing CTRL+d
+	#command_example();
+# setting to false would generate this
+#	command_example();
+# This setting works only for single line comments
+comment_use_indent=false
+
+# context action command (please see Geany's main documentation for details)
+context_action_cmd=
+
+[indentation]
+#width=4
+# 0 is spaces, 1 is tabs, 2 is tab & spaces
+#type=1
+
+
+[build_settings]
+# %f will be replaced by the complete filename
+# %e will be replaced by the filename without extension
+# (use only one of it at one time)
+compiler=run_cmd=abaqus job="%f" interactive datacheck
diff --git a/scintilla/Makefile.am b/scintilla/Makefile.am
index 3fbabad..97ba02d 100644
--- a/scintilla/Makefile.am
+++ b/scintilla/Makefile.am
@@ -6,6 +6,7 @@ noinst_LIBRARIES=libscintilla.a
 AM_CXXFLAGS = -DNDEBUG -DGTK -DSCI_LEXER -DG_THREADS_IMPL_NONE
 
 LEXER_SRCS= \
+lexers/LexAbaqus.cxx \
 lexers/LexAda.cxx \
 lexers/LexAsm.cxx \
 lexers/LexBash.cxx \
diff --git a/scintilla/lexers/LexAbaqus.cxx b/scintilla/lexers/LexAbaqus.cxx
new file mode 100644
index 0000000..267449f
--- /dev/null
+++ b/scintilla/lexers/LexAbaqus.cxx
@@ -0,0 +1,620 @@
+// Scintilla source code edit control
+/** @file LexABAQUS.cxx
+ ** Lexer for ABAQUS. Based on the lexer for APDL by Hadar Raz.
+ ** By Sergio Lucato.
+ ** Sort of completely rewritten by Gertjan Kloosterman
+ **/
+// The License.txt file describes the conditions under which this software may be distributed.
+
+// Code folding copyied and modified from LexBasic.cxx
+
+#include <stdlib.h>
+#include <string.h>
+#include <stdio.h>
+#include <stdarg.h>
+#include <assert.h>
+#include <ctype.h>
+
+#include "ILexer.h"
+#include "Scintilla.h"
+#include "SciLexer.h"
+
+#include "WordList.h"
+#include "LexAccessor.h"
+#include "Accessor.h"
+#include "StyleContext.h"
+#include "CharacterSet.h"
+#include "LexerModule.h"
+
+#ifdef SCI_NAMESPACE
+using namespace Scintilla;
+#endif
+
+static inline bool IsAWordChar(const int ch) {
+	return (ch < 0x80 && (isalnum(ch) || (ch == '_')));
+}
+
+static inline bool IsAKeywordChar(const int ch) {
+	return (ch < 0x80 && (isalnum(ch) || (ch == '_') || (ch == ' ')));
+}
+
+static inline bool IsASetChar(const int ch) {
+	return (ch < 0x80 && (isalnum(ch) || (ch == '_') || (ch == '.') || (ch == '-')));
+}
+
+static inline bool IsAnOperator(char ch) {
+	// '.' left out as it is used to make up numbers
+	if (ch == '*' || ch == '/' || ch == '-' || ch == '+' ||
+		ch == '(' || ch == ')' || ch == '=' || ch == '^' ||
+		ch == '[' || ch == ']' || ch == '<' || ch == '&' ||
+		ch == '>' || ch == ',' || ch == '|' || ch == '~' ||
+		ch == '$' || ch == ':' || ch == '%')
+		return true;
+	return false;
+}
+
+static void ColouriseABAQUSDoc(unsigned int startPos, int length, int initStyle, WordList*[] /* *keywordlists[] */,
+                            Accessor &styler) {
+	enum localState { KW_LINE_KW, KW_LINE_COMMA, KW_LINE_PAR, KW_LINE_EQ, KW_LINE_VAL, \
+					  DAT_LINE_VAL, DAT_LINE_COMMA,\
+					  COMMENT_LINE,\
+					  ST_ERROR, LINE_END } state ;
+
+	// Do not leak onto next line
+	state = LINE_END ;
+	initStyle = SCE_ABAQUS_DEFAULT;
+	StyleContext sc(startPos, length, initStyle, styler);
+
+	// Things are actually quite simple
+	// we have commentlines
+	// keywordlines and datalines
+	// On a data line there will only be colouring of numbers
+	// a keyword line is constructed as
+	// *word,[ paramname[=paramvalue]]*
+	// if the line ends with a , the keyword line continues onto the new line
+
+	for (; sc.More(); sc.Forward()) {
+		switch ( state ) {
+        case KW_LINE_KW :
+            if ( sc.atLineEnd ) {
+                // finished the line in keyword state, switch to LINE_END
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = LINE_END ;
+            } else if ( IsAKeywordChar(sc.ch) ) {
+                // nothing changes
+                state = KW_LINE_KW ;
+            } else if ( sc.ch == ',' ) {
+                // Well well we say a comma, arguments *MUST* follow
+                sc.SetState(SCE_ABAQUS_OPERATOR) ;
+                state = KW_LINE_COMMA ;
+            } else {
+                // Flag an error
+                sc.SetState(SCE_ABAQUS_PROCESSOR) ;
+                state = ST_ERROR ;
+            }
+            // Done with processing
+            break ;
+        case KW_LINE_COMMA :
+            // acomma on a keywordline was seen
+            if ( IsAKeywordChar(sc.ch)) {
+                sc.SetState(SCE_ABAQUS_ARGUMENT) ;
+                state = KW_LINE_PAR ;
+            } else if ( sc.atLineEnd || (sc.ch == ',') ) {
+                // we remain in keyword mode
+                state = KW_LINE_COMMA ;
+            } else if ( sc.ch == ' ' ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = KW_LINE_COMMA ;
+            } else {
+                // Anything else constitutes an error
+                sc.SetState(SCE_ABAQUS_PROCESSOR) ;
+                state = ST_ERROR ;
+            }
+            break ;
+        case KW_LINE_PAR :
+            if ( sc.atLineEnd ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = LINE_END ;
+            } else if ( IsAKeywordChar(sc.ch) || (sc.ch == '-') ) {
+                // remain in this state
+                state = KW_LINE_PAR ;
+            } else if ( sc.ch == ',' ) {
+                sc.SetState(SCE_ABAQUS_OPERATOR) ;
+                state = KW_LINE_COMMA ;
+            } else if ( sc.ch == '=' ) {
+                sc.SetState(SCE_ABAQUS_OPERATOR) ;
+                state = KW_LINE_EQ ;
+            } else {
+                // Anything else constitutes an error
+                sc.SetState(SCE_ABAQUS_PROCESSOR) ;
+                state = ST_ERROR ;
+            }
+            break ;
+        case KW_LINE_EQ :
+            if ( sc.ch == ' ' ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                // remain in this state
+                state = KW_LINE_EQ ;
+            } else if ( IsADigit(sc.ch) || (sc.ch == '-') || (sc.ch == '.' && IsADigit(sc.chNext)) ) {
+                sc.SetState(SCE_ABAQUS_NUMBER) ;
+                state = KW_LINE_VAL ;
+            } else if ( IsAKeywordChar(sc.ch) ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = KW_LINE_VAL ;
+            } else if ( (sc.ch == '\'') || (sc.ch == '\"') ) {
+                sc.SetState(SCE_ABAQUS_STRING) ;
+                state = KW_LINE_VAL ;
+            } else {
+                sc.SetState(SCE_ABAQUS_PROCESSOR) ;
+                state = ST_ERROR ;
+            }
+            break ;
+        case KW_LINE_VAL :
+            if ( sc.atLineEnd ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = LINE_END ;
+            } else if ( IsASetChar(sc.ch) && (sc.state == SCE_ABAQUS_DEFAULT) ) {
+                // nothing changes
+                state = KW_LINE_VAL ;
+            } else if (( (IsADigit(sc.ch) || sc.ch == '.' || (sc.ch == 'e' || sc.ch == 'E') ||
+                    ((sc.ch == '+' || sc.ch == '-') && (sc.chPrev == 'e' || sc.chPrev == 'E')))) &&
+                    (sc.state == SCE_ABAQUS_NUMBER)) {
+                // remain in number mode
+                state = KW_LINE_VAL ;
+            } else if (sc.state == SCE_ABAQUS_STRING) {
+                // accept everything until a closing quote
+                if ( sc.ch == '\'' || sc.ch == '\"' ) {
+                    sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                    state = KW_LINE_VAL ;
+                }
+            } else if ( sc.ch == ',' ) {
+                sc.SetState(SCE_ABAQUS_OPERATOR) ;
+                state = KW_LINE_COMMA ;
+            } else {
+                // anything else is an error
+                sc.SetState(SCE_ABAQUS_PROCESSOR) ;
+                state = ST_ERROR ;
+            }
+            break ;
+        case DAT_LINE_VAL :
+            if ( sc.atLineEnd ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = LINE_END ;
+            } else if ( IsASetChar(sc.ch) && (sc.state == SCE_ABAQUS_DEFAULT) ) {
+                // nothing changes
+                state = DAT_LINE_VAL ;
+            } else if (( (IsADigit(sc.ch) || sc.ch == '.' || (sc.ch == 'e' || sc.ch == 'E') ||
+                    ((sc.ch == '+' || sc.ch == '-') && (sc.chPrev == 'e' || sc.chPrev == 'E')))) &&
+                    (sc.state == SCE_ABAQUS_NUMBER)) {
+                // remain in number mode
+                state = DAT_LINE_VAL ;
+            } else if (sc.state == SCE_ABAQUS_STRING) {
+                // accept everything until a closing quote
+                if ( sc.ch == '\'' || sc.ch == '\"' ) {
+                    sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                    state = DAT_LINE_VAL ;
+                }
+            } else if ( sc.ch == ',' ) {
+                sc.SetState(SCE_ABAQUS_OPERATOR) ;
+                state = DAT_LINE_COMMA ;
+            } else {
+                // anything else is an error
+                sc.SetState(SCE_ABAQUS_PROCESSOR) ;
+                state = ST_ERROR ;
+            }
+            break ;
+        case DAT_LINE_COMMA :
+            // a comma on a data line was seen
+            if ( sc.atLineEnd ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = LINE_END ;
+            } else if ( sc.ch == ' ' ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = DAT_LINE_COMMA ;
+            } else if (sc.ch == ',')  {
+                sc.SetState(SCE_ABAQUS_OPERATOR) ;
+                state = DAT_LINE_COMMA ;
+            } else if ( IsADigit(sc.ch) || (sc.ch == '-')|| (sc.ch == '.' && IsADigit(sc.chNext)) ) {
+                sc.SetState(SCE_ABAQUS_NUMBER) ;
+                state = DAT_LINE_VAL ;
+            } else if ( IsAKeywordChar(sc.ch) ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = DAT_LINE_VAL ;
+            } else if ( (sc.ch == '\'') || (sc.ch == '\"') ) {
+                sc.SetState(SCE_ABAQUS_STRING) ;
+                state = DAT_LINE_VAL ;
+            } else {
+                sc.SetState(SCE_ABAQUS_PROCESSOR) ;
+                state = ST_ERROR ;
+            }
+            break ;
+        case COMMENT_LINE :
+            if ( sc.atLineEnd ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = LINE_END ;
+            }
+            break ;
+        case ST_ERROR :
+            if ( sc.atLineEnd ) {
+                sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                state = LINE_END ;
+            }
+            break ;
+        case LINE_END :
+            if ( sc.atLineEnd || sc.ch == ' ' ) {
+                // nothing changes
+                state = LINE_END ;
+            } else if ( sc.ch == '*' ) {
+                if ( sc.chNext == '*' ) {
+                    state = COMMENT_LINE ;
+                    sc.SetState(SCE_ABAQUS_COMMENT) ;
+                } else {
+                    state = KW_LINE_KW ;
+                    sc.SetState(SCE_ABAQUS_STARCOMMAND) ;
+                }
+            } else {
+                // it must be a data line, things are as if we are in DAT_LINE_COMMA
+                if ( sc.ch == ',' ) {
+                    sc.SetState(SCE_ABAQUS_OPERATOR) ;
+                    state = DAT_LINE_COMMA ;
+                } else if ( IsADigit(sc.ch) || (sc.ch == '-')|| (sc.ch == '.' && IsADigit(sc.chNext)) ) {
+                    sc.SetState(SCE_ABAQUS_NUMBER) ;
+                    state = DAT_LINE_VAL ;
+                } else if ( IsAKeywordChar(sc.ch) ) {
+                    sc.SetState(SCE_ABAQUS_DEFAULT) ;
+                    state = DAT_LINE_VAL ;
+                } else if ( (sc.ch == '\'') || (sc.ch == '\"') ) {
+                    sc.SetState(SCE_ABAQUS_STRING) ;
+                    state = DAT_LINE_VAL ;
+                } else {
+                    sc.SetState(SCE_ABAQUS_PROCESSOR) ;
+                    state = ST_ERROR ;
+                }
+            }
+            break ;
+		  }
+   }
+   sc.Complete();
+}
+
+//------------------------------------------------------------------------------
+// This copyied and modified from LexBasic.cxx
+//------------------------------------------------------------------------------
+
+/* Bits:
+ * 1  - whitespace
+ * 2  - operator
+ * 4  - identifier
+ * 8  - decimal digit
+ * 16 - hex digit
+ * 32 - bin digit
+ */
+static int character_classification[128] =
+{
+    0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  0,  0,  1,  0,  0,
+    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
+    1,  2,  0,  2,  2,  2,  2,  2,  2,  2,  6,  2,  2,  2,  10, 6,
+    60, 60, 28, 28, 28, 28, 28, 28, 28, 28, 2,  2,  2,  2,  2,  2,
+    2,  20, 20, 20, 20, 20, 20, 4,  4,  4,  4,  4,  4,  4,  4,  4,
+    4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2,  4,
+    2,  20, 20, 20, 20, 20, 20, 4,  4,  4,  4,  4,  4,  4,  4,  4,
+    4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  2,  2,  2,  0
+};
+
+static bool IsSpace(int c) {
+	return c < 128 && (character_classification[c] & 1);
+}
+
+static bool IsIdentifier(int c) {
+	return c < 128 && (character_classification[c] & 4);
+}
+
+static int LowerCase(int c)
+{
+	if (c >= 'A' && c <= 'Z')
+		return 'a' + c - 'A';
+	return c;
+}
+
+static int LineEnd(int line, Accessor &styler)
+{
+    const int docLines = styler.GetLine(styler.Length() - 1);  // Available last line
+    int eol_pos ;
+    // if the line is the last line, the eol_pos is styler.Length()
+    // eol will contain a new line, or a virtual new line
+    if ( docLines == line )
+        eol_pos = styler.Length() ;
+    else
+        eol_pos = styler.LineStart(line + 1) - 1;
+    return eol_pos ;
+}
+
+static int LineStart(int line, Accessor &styler)
+{
+    return styler.LineStart(line) ;
+}
+
+// LineType
+//
+// bits determines the line type
+// 1  : data line
+// 2  : only whitespace
+// 3  : data line with only whitespace
+// 4  : keyword line
+// 5  : block open keyword line
+// 6  : block close keyword line
+// 7  : keyword line in error
+// 8  : comment line
+static int LineType(int line, Accessor &styler) {
+    int pos = LineStart(line, styler) ;
+    int eol_pos = LineEnd(line, styler) ;
+
+    int c ;
+    char ch = ' ';
+
+    int i = pos ;
+    while ( i < eol_pos ) {
+        c = styler.SafeGetCharAt(i);
+        ch = static_cast<char>(LowerCase(c));
+        // We can say something as soon as no whitespace
+        // was encountered
+        if ( !IsSpace(c) )
+            break ;
+        i++ ;
+    }
+
+    if ( i >= eol_pos ) {
+        // This is a whitespace line, currently
+        // classifies as data line
+        return 3 ;
+    }
+
+    if ( ch != '*' ) {
+        // This is a data line
+        return 1 ;
+    }
+
+    if ( i == eol_pos - 1 ) {
+        // Only a single *, error but make keyword line
+        return 4+3 ;
+    }
+
+    // This means we can have a second character
+    // if that is also a * this means a comment
+    // otherwise it is a keyword.
+    c = styler.SafeGetCharAt(i+1);
+    ch = static_cast<char>(LowerCase(c));
+    if ( ch == '*' ) {
+        return 8 ;
+    }
+
+    // At this point we know this is a keyword line
+    // the character at position i is a *
+    // it is not a comment line
+    char word[256] ;
+    int  wlen = 0;
+
+    word[wlen] = '*' ;
+	wlen++ ;
+
+    i++ ;
+    while ( (i < eol_pos) && (wlen < 255) ) {
+        c = styler.SafeGetCharAt(i);
+        ch = static_cast<char>(LowerCase(c));
+
+        if ( (!IsSpace(c)) && (!IsIdentifier(c)) )
+            break ;
+
+        if ( IsIdentifier(c) ) {
+            word[wlen] = ch ;
+			wlen++ ;
+		}
+
+        i++ ;
+    }
+
+    word[wlen] = 0 ;
+
+    // Make a comparison
+	if ( !strcmp(word, "*step") ||
+         !strcmp(word, "*part") ||
+         !strcmp(word, "*instance") ||
+         !strcmp(word, "*assembly")) {
+       return 4+1 ;
+    }
+
+	if ( !strcmp(word, "*endstep") ||
+         !strcmp(word, "*endpart") ||
+         !strcmp(word, "*endinstance") ||
+         !strcmp(word, "*endassembly")) {
+       return 4+2 ;
+    }
+
+    return 4 ;
+}
+
+static void SafeSetLevel(int line, int level, Accessor &styler)
+{
+    if ( line < 0 )
+        return ;
+
+    int mask = ((~SC_FOLDLEVELHEADERFLAG) | (~SC_FOLDLEVELWHITEFLAG));
+
+    if ( (level & mask) < 0 )
+        return ;
+
+    if ( styler.LevelAt(line) != level )
+        styler.SetLevel(line, level) ;
+}
+
+static void FoldABAQUSDoc(unsigned int startPos, int length, int,
+WordList *[], Accessor &styler) {
+    int startLine = styler.GetLine(startPos) ;
+    int endLine   = styler.GetLine(startPos+length-1) ;
+
+    // bool foldCompact = styler.GetPropertyInt("fold.compact", 1) != 0;
+    // We want to deal with all the cases
+    // To know the correct indentlevel, we need to look back to the
+    // previous command line indentation level
+	// order of formatting keyline datalines commentlines
+    int beginData    = -1 ;
+    int beginComment = -1 ;
+    int prvKeyLine   = startLine ;
+    int prvKeyLineTp =  0 ;
+
+    // Scan until we find the previous keyword line
+    // this will give us the level reference that we need
+    while ( prvKeyLine > 0 ) {
+        prvKeyLine-- ;
+        prvKeyLineTp = LineType(prvKeyLine, styler) ;
+        if ( prvKeyLineTp & 4 )
+            break ;
+    }
+
+    // Determine the base line level of all lines following
+    // the previous keyword
+    // new keyword lines are placed on this level
+    //if ( prvKeyLineTp & 4 ) {
+    int level = styler.LevelAt(prvKeyLine) & ~SC_FOLDLEVELHEADERFLAG ;
+    //}
+
+    // uncomment line below if weird behaviour continues
+    prvKeyLine = -1 ;
+
+    // Now start scanning over the lines.
+    for ( int line = startLine; line <= endLine; line++ ) {
+        int lineType = LineType(line, styler) ;
+
+        // Check for comment line
+        if ( lineType == 8 ) {
+            if ( beginComment < 0 ) {
+                beginComment = line ;
+			}
+        }
+
+        // Check for data line
+        if ( (lineType == 1) || (lineType == 3) ) {
+            if ( beginData < 0 ) {
+                if ( beginComment >= 0 ) {
+                    beginData = beginComment ;
+                } else {
+                    beginData = line ;
+                }
+            }
+			beginComment = -1 ;
+		}
+
+        // Check for keywordline.
+        // As soon as a keyword line is encountered, we can set the
+        // levels of everything from the previous keyword line to this one
+        if ( lineType & 4 ) {
+            // this is a keyword, we can now place the previous keyword
+            // all its data lines and the remainder
+
+            // Write comments and data line
+            if ( beginComment < 0 ) {
+                beginComment = line ;
+			}
+
+            if ( beginData < 0 ) {
+                beginData = beginComment ;
+				if ( prvKeyLineTp != 5 )
+					SafeSetLevel(prvKeyLine, level, styler) ;
+				else
+					SafeSetLevel(prvKeyLine, level | SC_FOLDLEVELHEADERFLAG, styler) ;
+            } else {
+                SafeSetLevel(prvKeyLine, level | SC_FOLDLEVELHEADERFLAG, styler) ;
+            }
+
+            int datLevel = level + 1 ;
+			if ( !(prvKeyLineTp & 4) ) {
+				datLevel = level ;
+			}
+
+            for ( int ll = beginData; ll < beginComment; ll++ )
+                SafeSetLevel(ll, datLevel, styler) ;
+
+            // The keyword we just found is going to be written at another level
+            // if we have a type 5 and type 6
+            if ( prvKeyLineTp == 5 ) {
+                level += 1 ;
+			}
+
+            if ( prvKeyLineTp == 6 ) {
+                level -= 1 ;
+				if ( level < 0 ) {
+					level = 0 ;
+				}
+            }
+
+            for ( int lll = beginComment; lll < line; lll++ )
+                SafeSetLevel(lll, level, styler) ;
+
+            // wrap and reset
+            beginComment = -1 ;
+            beginData    = -1 ;
+            prvKeyLine   = line ;
+            prvKeyLineTp = lineType ;
+        }
+
+    }
+
+    if ( beginComment < 0 ) {
+        beginComment = endLine + 1 ;
+    } else {
+        // We need to find out whether this comment block is followed by
+        // a data line or a keyword line
+        const int docLines = styler.GetLine(styler.Length() - 1);
+
+        for ( int line = endLine + 1; line <= docLines; line++ ) {
+            int lineType = LineType(line, styler) ;
+
+            if ( lineType != 8 ) {
+				if ( !(lineType & 4) )  {
+					beginComment = endLine + 1 ;
+				}
+                break ;
+			}
+        }
+    }
+
+    if ( beginData < 0 ) {
+        beginData = beginComment ;
+		if ( prvKeyLineTp != 5 )
+			SafeSetLevel(prvKeyLine, level, styler) ;
+		else
+			SafeSetLevel(prvKeyLine, level | SC_FOLDLEVELHEADERFLAG, styler) ;
+    } else {
+        SafeSetLevel(prvKeyLine, level | SC_FOLDLEVELHEADERFLAG, styler) ;
+    }
+
+    int datLevel = level + 1 ;
+	if ( !(prvKeyLineTp & 4) ) {
+		datLevel = level ;
+	}
+
+    for ( int ll = beginData; ll < beginComment; ll++ )
+        SafeSetLevel(ll, datLevel, styler) ;
+
+	if ( prvKeyLineTp == 5 ) {
+		level += 1 ;
+	}
+
+	if ( prvKeyLineTp == 6 ) {
+		level -= 1 ;
+	}
+	for ( int m = beginComment; m <= endLine; m++ )
+        SafeSetLevel(m, level, styler) ;
+}
+
+static const char * const abaqusWordListDesc[] = {
+    "processors",
+    "commands",
+    "slashommands",
+    "starcommands",
+    "arguments",
+    "functions",
+    0
+};
+
+LexerModule lmAbaqus(SCLEX_ABAQUS, ColouriseABAQUSDoc, "abaqus", FoldABAQUSDoc, abaqusWordListDesc);
diff --git a/scintilla/makefile.win32 b/scintilla/makefile.win32
index 2c7b466..ccb1f51 100644
--- a/scintilla/makefile.win32
+++ b/scintilla/makefile.win32
@@ -63,6 +63,7 @@ MARSHALLER=scintilla-marshal.o
 	$(CC) $(CXXFLAGS) -c $<
 
 LEXOBJS=\
+LexAbaqus.o \
 LexAda.o \
 LexAsm.o \
 LexBash.o \
diff --git a/scintilla/src/Catalogue.cxx b/scintilla/src/Catalogue.cxx
index 257ba28..37b2a3c 100644
--- a/scintilla/src/Catalogue.cxx
+++ b/scintilla/src/Catalogue.cxx
@@ -81,6 +81,7 @@ int Scintilla_LinkLexers() {
 
 //++Autogenerated -- run src/LexGen.py to regenerate
 //**\(\tLINK_LEXER(\*);\n\)
+	LINK_LEXER(lmAbaqus);
 	LINK_LEXER(lmAda);
 	LINK_LEXER(lmAsm);
 	LINK_LEXER(lmBash);
diff --git a/src/filetypes.c b/src/filetypes.c
index 547c135..60fec9e 100644
--- a/src/filetypes.c
+++ b/src/filetypes.c
@@ -496,6 +496,14 @@ static void init_builtin_filetypes(void)
 	ft->name = g_strdup("Forth");
 	filetype_make_title(ft, TITLE_SOURCE_FILE);
 	ft->group = GEANY_FILETYPE_GROUP_SCRIPT;
+
+#define ABAQUS
+	ft = filetypes[GEANY_FILETYPES_ABAQUS];
+	ft->lang = 43;
+	ft->name = g_strdup("Abaqus");
+	filetype_make_title(ft, TITLE_SOURCE_FILE);
+	ft->mime_type = g_strdup("text/x-abaqus");
+	ft->group = GEANY_FILETYPE_GROUP_SCRIPT;
 }
 
 
diff --git a/src/filetypes.h b/src/filetypes.h
index 8164a44..0bce769 100644
--- a/src/filetypes.h
+++ b/src/filetypes.h
@@ -80,6 +80,7 @@ typedef enum
 	GEANY_FILETYPES_JS,
 	GEANY_FILETYPES_VHDL,
 	GEANY_FILETYPES_ADA,
+	GEANY_FILETYPES_ABAQUS,
 	GEANY_FILETYPES_CMAKE,
 	GEANY_FILETYPES_MARKDOWN,
 	GEANY_FILETYPES_TXT2TAGS,
diff --git a/src/highlighting.c b/src/highlighting.c
index 21323e7..ee823a4 100644
--- a/src/highlighting.c
+++ b/src/highlighting.c
@@ -1039,6 +1039,7 @@ void highlighting_init_styles(guint filetype_idx, GKeyFile *config, GKeyFile *co
 
 	switch (lexer_id)
 	{
+		init_styleset_case(ABAQUS);
 		init_styleset_case(ADA);
 		init_styleset_case(ASM);
 		init_styleset_case(BASIC);
@@ -1118,6 +1119,7 @@ void highlighting_set_styles(ScintillaObject *sci, GeanyFiletype *ft)
 
 	switch (lexer_id)
 	{
+		styleset_case(ABAQUS);
 		styleset_case(ADA);
 		styleset_case(ASM);
 		styleset_case(BASIC);
@@ -1563,6 +1565,9 @@ gboolean highlighting_is_string_style(gint lexer, gint style)
 				style == SCE_ADA_STRING ||
 				style == SCE_ADA_CHARACTEREOL ||
 				style == SCE_ADA_STRINGEOL);
+
+		case SCLEX_ABAQUS:
+			return (style == SCE_ABAQUS_STRING);
 	}
 	return FALSE;
 }
@@ -1700,6 +1705,10 @@ gboolean highlighting_is_comment_style(gint lexer, gint style)
 			return (style == SCE_ADA_COMMENTLINE ||
 				style == SCE_NSIS_COMMENTBOX);
 
+		case SCLEX_ABAQUS:
+			return (style == SCE_ABAQUS_COMMENT ||
+				 style == SCE_ABAQUS_COMMENTBLOCK);
+
 		case SCLEX_ASM:
 			return (style == SCE_ASM_COMMENT ||
 				style == SCE_ASM_COMMENTBLOCK ||
diff --git a/src/highlightingmappings.h b/src/highlightingmappings.h
index 3971760..1434e3c 100644
--- a/src/highlightingmappings.h
+++ b/src/highlightingmappings.h
@@ -69,6 +69,31 @@ typedef struct
 #define HL_N_ENTRIES(array) ((array != NULL) ? G_N_ELEMENTS(array) : 0)
 
 
+/* Abaqus */
+#define highlighting_lexer_ABAQUS			SCLEX_ABAQUS
+static const HLStyle highlighting_styles_ABAQUS[] =
+{
+	{ SCE_ABAQUS_DEFAULT,		"default",		FALSE },
+	{ SCE_ABAQUS_COMMENT,		"comment",		FALSE },
+	{ SCE_ABAQUS_COMMENTBLOCK,	"commentblock",		FALSE },
+	{ SCE_ABAQUS_NUMBER,		"number",		FALSE },
+	{ SCE_ABAQUS_STRING,		"string",		FALSE },
+	{ SCE_ABAQUS_OPERATOR,		"operator",		FALSE },
+	{ SCE_ABAQUS_WORD,		"word",			FALSE },
+	{ SCE_ABAQUS_PROCESSOR,		"preprocessor",		FALSE },
+	{ SCE_ABAQUS_COMMAND,		"command",		FALSE },
+	{ SCE_ABAQUS_SLASHCOMMAND,	"command",		FALSE },
+	{ SCE_ABAQUS_STARCOMMAND,	"command",		FALSE },
+	{ SCE_ABAQUS_ARGUMENT,		"word2",		FALSE },
+	{ SCE_ABAQUS_FUNCTION,		"function",		FALSE }
+};
+static const HLKeyword highlighting_keywords_ABAQUS[] =
+{
+	{ 0, "primary",	FALSE }
+};
+#define highlighting_properties_ABAQUS		EMPTY_PROPERTIES
+
+
 /* Ada */
 #define highlighting_lexer_ADA			SCLEX_ADA
 static const HLStyle highlighting_styles_ADA[] =
diff --git a/src/symbols.c b/src/symbols.c
index c55a4ea..4b3928d 100644
--- a/src/symbols.c
+++ b/src/symbols.c
@@ -754,6 +754,17 @@ static void add_top_level_items(GeanyDocument *doc)
 				NULL);
 			break;
 		}
+
+		case GEANY_FILETYPES_ABAQUS:
+		{
+			tag_list_add_groups(tag_store,
+				&(tv_iters.tag_class), _("Parts"), NULL,
+				&(tv_iters.tag_member), _("Assembly"), NULL,
+				&(tv_iters.tag_namespace), _("Steps"), NULL,
+				NULL);
+			break;
+		}
+		
 		case GEANY_FILETYPES_R:
 		{
 			tag_list_add_groups(tag_store,
diff --git a/tagmanager/ctags/Makefile.am b/tagmanager/ctags/Makefile.am
index f067345..b2b7a3f 100644
--- a/tagmanager/ctags/Makefile.am
+++ b/tagmanager/ctags/Makefile.am
@@ -11,6 +11,7 @@ EXTRA_DIST = \
 noinst_LIBRARIES = libctags.a
 
 parsers = \
+	abaqus.c \
 	abc.c \
 	actionscript.c \
 	asm.c \
diff --git a/tagmanager/ctags/abaqus.c b/tagmanager/ctags/abaqus.c
new file mode 100644
index 0000000..eae683f
--- /dev/null
+++ b/tagmanager/ctags/abaqus.c
@@ -0,0 +1,126 @@
+/*
+ *   This source code is released for free distribution under the terms of the
+ *   GNU General Public License.
+ *
+ *   This module contains functions for generating tags for source files
+ *   for inp files (Abaqus).
+ */
+
+/*
+*   INCLUDE FILES
+*/
+#include "general.h"	/* must always come first */
+
+#include <ctype.h>
+#include <string.h>
+
+#include "parse.h"
+#include "read.h"
+#include "vstring.h"
+
+/*
+*   DATA DEFINITIONS
+*/
+typedef enum {
+	K_PART,
+	K_ASSEMBLY,
+	K_STEP
+} AbaqusKind;
+
+static kindOption AbaqusKinds[] = {
+     { TRUE, 'c', "class",      "Parts" },
+     { TRUE, 'm', "member",      "Assembly" },
+     { TRUE, 'n', "namespace",      "Steps" }
+};
+
+/*
+*   FUNCTION DEFINITIONS
+*/
+
+static int getWord(const char *ref, const char **ptr)
+{
+	const char *p = *ptr;
+
+	while ((*ref != '\0') && (*p != '\0') && (tolower(*ref) == tolower(*p))) ref++, p++;
+
+	if (*ref) return FALSE;
+
+	*ptr = p;
+	return TRUE;
+}
+
+
+static void createTag(AbaqusKind kind, const char *buf)
+{
+	vString *name;
+
+	if (*buf == '\0') return;
+
+	buf = strstr(buf, "=");
+	if (buf == NULL) return;
+
+	buf += 1;
+
+	if (*buf == '\0') return;
+
+	name = vStringNew();
+
+	do
+	{
+		vStringPut(name, (int) *buf);
+		++buf;
+	} while ((*buf != '\0') && (*buf != ','));
+	vStringTerminate(name);
+	makeSimpleTag(name, AbaqusKinds, kind);
+}
+
+
+static void findAbaqusTags(void)
+{
+	const char *line;
+
+	while ((line = (const char*)fileReadLine()) != NULL)
+	{
+		const char *cp = line;
+
+		for (; *cp != '\0'; cp++)
+		{
+			if (*cp == '*')
+			{
+				cp++;
+
+				/* Parts*/
+				if (getWord("part", &cp))
+				{
+					createTag(K_PART, cp);
+					continue;
+				}
+				/* Assembly */
+				if (getWord("assembly", &cp))
+				{
+					createTag(K_ASSEMBLY, cp);
+					continue;
+				}
+				/* Steps */
+				if (getWord("step", &cp))
+				{
+					createTag(K_STEP, cp);
+					continue;
+				}
+				
+			}
+		}
+	}
+}
+
+
+extern parserDefinition* AbaqusParser (void)
+{
+	static const char *const extensions [] = { "inp", NULL };
+	parserDefinition * def = parserNew ("Abaqus");
+	def->kinds      = AbaqusKinds;
+	def->kindCount  = KIND_COUNT (AbaqusKinds);
+	def->extensions = extensions;
+	def->parser     = findAbaqusTags;
+	return def;
+}
diff --git a/tagmanager/ctags/makefile.win32 b/tagmanager/ctags/makefile.win32
index 8a9039b..694b601 100644
--- a/tagmanager/ctags/makefile.win32
+++ b/tagmanager/ctags/makefile.win32
@@ -44,7 +44,7 @@ all: $(COMPLIB)
 clean:
 	-$(RM) deps.mak *.o $(COMPLIB)
 
-$(COMPLIB): abc.o args.o c.o cobol.o fortran.o make.o conf.o pascal.o perl.o php.o diff.o vhdl.o verilog.o lua.o js.o \
+$(COMPLIB): abaqus.o abc.o args.o c.o cobol.o fortran.o make.o conf.o pascal.o perl.o php.o diff.o vhdl.o verilog.o lua.o js.o \
 actionscript.o nsis.o objc.o \
 haskell.o haxe.o html.o python.o lregex.o rest.o sh.o ctags.o entry.o get.o keyword.o nestlevel.o \
 options.o \
diff --git a/tagmanager/ctags/parsers.h b/tagmanager/ctags/parsers.h
index 1773d30..84f6d13 100644
--- a/tagmanager/ctags/parsers.h
+++ b/tagmanager/ctags/parsers.h
@@ -57,7 +57,8 @@
     VerilogParser, \
     RParser, \
     CobolParser, \
-    ObjcParser
+    ObjcParser, \
+    AbaqusParser
 /*
 langType of each parser
  0	CParser
@@ -103,6 +104,7 @@ langType of each parser
 40	RParser
 41	CobolParser
 42	ObjcParser
+43	AbaqusParser
 */
 #endif	/* _PARSERS_H */
 
diff --git a/wscript b/wscript
index 1617b5d..96580a2 100644
--- a/wscript
+++ b/wscript
@@ -61,6 +61,7 @@ out = '_build_'
 mio_sources = set(['tagmanager/mio/mio.c'])
 
 ctags_sources = set([
+    'tagmanager/ctags/abaqus.c',
     'tagmanager/ctags/args.c',
     'tagmanager/ctags/abc.c',
     'tagmanager/ctags/actionscript.c',
-- 
1.7.10.4

